/*
 * 助利宝返利明细表
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class HelpProfitRebateDetailController : BaseController
    {
        public HelpProfitRebateDetailController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 助利宝返利明细表列表

        /// <summary>
        /// 根据条件查询助利宝返利明细表列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(HelpProfitRebateDetail data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询助利宝返利明细表列表

        /// <summary>
        /// 助利宝返利明细表列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(HelpProfitRebateDetail data, string ProductTypeSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //产品类型
            if (!string.IsNullOrEmpty(ProductTypeSelect))
            {
                condition += " and ProductType=" + ProductTypeSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitRebateDetail", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //产品类型
                int ProductType = int.Parse(dic["ProductType"].ToString());
                if (ProductType == 1) dic["ProductType"] = "在线办卡";
                if (ProductType == 3) dic["ProductType"] = "系统奖励";
                if (ProductType == 4) dic["ProductType"] = "灵动商城";
                if (ProductType == 5) dic["ProductType"] = "快钱Mpos";
                if (ProductType == 0) dic["ProductType"] = "";

            }
            return Json(obj);
        }

        #endregion

        #region 增加助利宝返利明细表

        /// <summary>
        /// 增加或修改助利宝返利明细表信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加助利宝返利明细表

        /// <summary>
        /// 增加或修改助利宝返利明细表信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(HelpProfitRebateDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("HelpProfitRebateDetail", Fields, 0);
            AddSysLog(data.Id.ToString(), "HelpProfitRebateDetail", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改助利宝返利明细表

        /// <summary>
        /// 增加或修改助利宝返利明细表信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            HelpProfitRebateDetail editData = db.HelpProfitRebateDetail.FirstOrDefault(m => m.Id == Id) ?? new HelpProfitRebateDetail();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改助利宝返利明细表

        /// <summary>
        /// 增加或修改助利宝返利明细表信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(HelpProfitRebateDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Remark", data.Remark); //备注

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitRebateDetail", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "HelpProfitRebateDetail", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除助利宝返利明细表信息

        /// <summary>
        /// 删除助利宝返利明细表信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitRebateDetail", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitRebateDetail", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitRebateDetail", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitRebateDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitRebateDetail", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitRebateDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("HelpProfitRebateDetail", Sort, Id);

            AddSysLog(Id.ToString(), "HelpProfitRebateDetail", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.HelpProfitRebateDetail.Add(new HelpProfitRebateDetail()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "HelpProfitRebateDetail", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(HelpProfitRebateDetail data, string ProductTypeSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //产品类型
            if (!string.IsNullOrEmpty(ProductTypeSelect))
            {
                condition += " and ProductType=" + ProductTypeSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitRebateDetail", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //产品类型
                int ProductType = int.Parse(dic["ProductType"].ToString());
                if (ProductType == 1) dic["ProductType"] = "在线办卡";
                if (ProductType == 3) dic["ProductType"] = "系统奖励";
                if (ProductType == 4) dic["ProductType"] = "灵动商城";
                if (ProductType == 5) dic["ProductType"] = "快钱Mpos";
                if (ProductType == 0) dic["ProductType"] = "";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "HelpProfitRebateDetail", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
